TTU5   ; ttu5/asm
 SCOPY	LD	A,2
 	LD	(FMTYPE),A
 	XOR	A
 	LD	(STARTTRK),A
 	RST	8
 	DB	10,'Source.',0
 	CALL	ONEDRIVE
 	LD	A,(DRIV)	;get the drive
 	LD	(SDRIVE),A	;save it
 	RST	8
 	DB	10,'Destination.',0
 	CALL	GETDRIVES	;can use all 4
 	RST	8
 	DB	10,0
 	XOR	A
 	LD	(POSA),A	;start position
 	DEC	A
 	LD	(MFLAG),A
 	LD	A,(SDRIVE)
 	LD	HL,TYPEB
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)
 	AND	4
 	JR	Z,ASKIFFMT
 	XOR	A
 	LD	(MFLAG),A
 ASKIFFMT	RST	8
 	DB	1EH,'Format Drives ? ',0
 	XOR	A
 	LD	(SKVER),A
 	LD	(HASDATFLG),A
 	INC	A
 	LD	(IFBFMT),A
 	LD	B,3
 	RST	10H
 	JR	Z,SCOPYOLOOP
 	CALL	POSHL
 	JR	C,SCOPYOLOOP
 AKBAK	CALL	POSHL
 	JR	C,ANOBAK
 	CALL	UCASE
 	CP	'*'
 	JR	Z,BAKVERSKP
 	CP	'!'
 	JR	Z,BAKFMTSK
 	CP	'Y'
 	JR	Z,BAKFMT0
 	CP	'N'
 	JR	Z,BAKFMT1
 	JR	ASKIFFMT
 BAKVERSKP	LD	A,1
 	LD	(SKVER),A
 BAKVGO	INC	HL
 	JR	AKBAK
 BAKFMTSK	LD	A,1
 	LD	(HASDATFLG),A
 BAKFMT0	LD	A,1
 	LD	(IFBFMT),A
 	JR	BAKVGO
 BAKFMT1	XOR	A
 	JR	BAKFMT0+2
 ANOBAK	LD	A,0
 IFBFMT	EQU	$-1
 	DEC	A
 	JR	NZ,SCOPYBAK
 SCOPYOLOOP	RST	8
 	DB	10,'Mount DESTINATION diskettes. ',0
 	CALL	ONEKEY
 	RST	8
 	DB	10,0
 	LD	DE,SCOPYO
 	LD	BC,SCOPYBAK	;return here
 	JP	DRVCOMM		;do all dest drives
 SCOPYO	CALL	DSTAT		;is drive ready?
 	RET	NZ
 	JP	C,REMDRIVE
 	CALL	RESTORE
 	RET	NZ
 	JP	FORMIT		;format it
 SCOPYBAK	LD	A,(SDRIVE)
 	CALL	SETDRV
 	LD	BC,SCOPYI
 	PUSH	BC
 	PUSH	BC
 	JP	CNTOTAL
 SCOPYI	LD	(TEMP2),HL
 	LD	HL,0
 	OR	A
 	CALL	GETTYPEA
 	BIT	7,A
 	JR	Z,HAPZ
 	INC	L
 HAPZ	LD	(TEMP0),HL
 	CALL	INITBAD1
 	RST	8
 	DB	10,0
 SCOPYLP	LD	HL,TYPEB
 	LD	BC,0400H
 SCOPYCK	LD	A,(HL)
 	AND	4
 	JR	NZ,SCOPYCK0
 	INC	HL
 	DJNZ	SCOPYCK
 	RST	8
 	DB	10,'No Destination Drives !',0
 	JP	GOBACK
 SCOPYCK0	LD	HL,TYPEB
 	LD	A,(SDRIVE)
 	ADD	A,L
 	LD	L,A
 	BIT	2,(HL)
 	LD	A,(SDRIVE)
 	JR	NZ,MSTMNT
 	INC	A
 MSTMNT	LD	(DDRIVE),A
 	LD	DE,(TEMP0)
 	LD	(TEMP1),DE
 	LD	HL,(TEMP2)
 	LD	BC,GATBUFF
 	LD	A,(SDRIVE)
 	CALL	SETDRV
 	CALL	DRVSAME
 	CALL	Z,SMOUNT
 	PUSH	HL
 	CALL	MREAD
 	LD	(TEMP2),HL
 	LD	(TEMP0),DE
 	LD	B,H
 	LD	C,L
 	POP	HL
 	OR	A
 	SBC	HL,BC
 	LD	(TEMP3),HL
 	LD	DE,CPLP1
 	LD	BC,CPLP2
 	JP	DRVCOMM
 CPLP1	LD	A,(DRIV)
 	LD	(DDRIVE),A
 	CALL	DRVSAME
 	CALL	Z,DMOUNT
 	LD	HL,(TEMP3)
 	LD	DE,(TEMP1)
 	LD	BC,GATBUFF
 	CALL	DSTAT
 	RET	NZ
 	JR	C,REMDRIVE
 	CALL	MWRITE
 	JR	CPYVER
 REMDRIVE	LD	A,(DRIV)
 	LD	HL,TYPEB
 	ADD	A,L
 	LD	L,A
 	RES	2,(HL)
 	RET
 CPYVER	LD	A,0
 SKVER	EQU	$-1
 	DEC	A
 	RET	Z
 	LD	HL,(TEMP3)
 	LD	DE,(TEMP1)
 	LD	BC,GATBUFF
 	LD	(TEMP9),BC
 CPYVER1	PUSH	HL
 	LD	BC,DAMBUFF
 	CALL	SHOVERIFY
 	POP	HL
 	PUSH	HL
 	LD	HL,(TEMP9)
 	PUSH	DE
 	LD	DE,DAMBUFF
 	LD	B,0
 	CALL	COMPARE
 	CALL	NZ,NOGOODV
 	LD	HL,(TEMP9)
 	INC	H
 	LD	(TEMP9),HL
 	POP	DE
 	POP	HL
 	CALL	NEXSEC
 	DEC	HL
 	LD	A,H
 	OR	L
 	JR	NZ,CPYVER1
 	RET
 CPLP2	LD	HL,(TEMP2)
 	LD	A,H
 	OR	L
 	JP	NZ,SCOPYLP
 	LD	DE,CPLPX
 	LD	BC,CPLPY
 	JP	DRVCOMM
 CPLPX	LD	DE,(TEMP0)
 	CALL	NEXSEC
 	RET	C
 	CALL	RETSEC
 CPLPZ	LD	BC,BUFFER
 	CALL	SHOVERIFY
 	CALL	NEXSEC
 	JR	NC,CPLPZ
 UPDIRX	OR	A
 	CALL	GETTKS
 	RST	18H
 	LD	(UPDIRY),A
 	LD	(UPDIRY+1),BC
 	RST	8
 	DB	10,'Updating Directory to '
 UPDIRY	DB	'xxx Tracks.',10,0
 	CALL	RDDIR
 	JR	C,UPDIRZ
 	CALL	MAKEGAT+3
 	JP	WRDIR
 UPDIRZ	RST	8
 	DB	1EH,'Cannot Update Directory !',10,0
 	RET
 CPLPY	RST	8
 	DB	10,0
 	JP	SFMT4
 NOGOODV	RST	8
 	DB	'  ** BAD **',10,0
 	RET
