TTBOOT ; ttboot1/asm
 	ORG	4200H
 	LD	L,H		;L = 37H
 	LD	H,B		;H = 42H
 	PUSH	HL
 LOOP1	LD	A,(HL)		;get a byte
 	XOR	D		;fix it
 	XOR	E		;fix it again
 	LD	(HL),A
 	INC	L
 	JR	NZ,LOOP1	;L=0, Z flag
 	RET
 	LD	B,H
 	XOR	E
 	LD	L,C
 	BIT	0,(HL)
 	JR	NZ,$-7
 	PUSH	HL
 	LD	SP,37H
 	RET
 	POP	BC
 	POP	HL
 	PUSH	AF
 	RET
 	LD	(HL),E
 	INC	E
 	DEC	L
 	LD	B,(HL)
 	DJNZ	$-4
 	EXX
 	EX	AF,AF'
 	PUSH	AF
 	LD	E,A
 	POP	BC
 	LDIR
 	IN	A,(44H)
 	AND	H
 	JR	NZ,$-6
 	PUSH	BC
 	LD	A,(BC)
 	DEC	B
 	JP	4294H
 	RST	38H
 	PUSH	BC
 	RETN
 ;	ORG	4237H
 	EX	DE,HL		;HL = 37EFH
 	LD	D,C		;D = 0
 	INC	E		;E = 1
 	INC	E		;E = 2
 	INC	B		;BC = 4300H
 	PUSH	BC		;4300 vector
 LOAD	LD	(HL),D		;give desired track
 	LD	A,D		;get track
 	XOR	E		;xor with sector
 	PUSH	DE		;save track sector
 	PUSH	HL		;give HL => DE
 	POP	DE
 	DEC	L		;HL = 37EEH
 	LD	(HL),A		;desired sector
 	DEC	L		;HL = 37EDH
 	DEC	L		;HL = 37ECH
 	LD	(HL),10H	;issue seek
 	CALL	SLOW
 WAIT1	BIT	0,(HL)		;command done?
 	JR	NZ,WAIT1	;wait if not
 	LD	(HL),80H	;non-ibm read
 	CALL	SLOW
 LOOP2	RRCA
 	JR	NC,LOOP4	;done
 LOOP3	LD	A,(HL)		;get status byte
 	BIT	1,A		;byte ready?
 	JR	NZ,LOOP2	;see if command done
 	LD	A,(DE)		;get the byte
 	XOR	C		;make it right
 	DEC	C		;less position
 	LD	(BC),A		;put in buffer
 	JR	NZ,LOOP3	;go more if not done
 LOOP4	LD	A,(HL)		;get status
 	LD	(HL),0D0H	;interrupt out
 	POP	DE		;get track/sector back
 	OR	A		;see if any errors
 	RET	Z
 	LD	HL,DERROR
 	JR	ERROR
 MERR	LD	HL,MERROR
 ERROR	LD	A,(HL)
 	INC	L
 	CALL	33H
 	OR	A
 	JR	NZ,ERROR
 	LD	H,0		;move to ROM
 	CALL	40H
 	HALT			;re-boot
 SLOW	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	LD	A,(HL)
 	RET
 MERROR	DB	1CH,1FH,'Memory Error !',0
 DERROR	DB	1CH,1FH,'Disk Error !',0
 	END
